/*
         mySPI.h
 
 (c)2014 ARPix / Alexander Röhl

*/
 

#ifndef _mySPI_H_INCLUDED
#define _mySPI_H_INCLUDED

#include <avr/interrupt.h>
#include <avr/io.h>
#include <util/delay.h>
#include <wiring.h>
#include "Arduino.h"


#define _CD   9
#define _MOSI 11
#define _SCK  13


class mySPI  {
public:
  static void Init(void);
  static unsigned char send(unsigned char);
private:
  
};

extern mySPI spi;

#endif


//void mySPI::setChipSelectPin(uint8_t const val) {
//  _CS_PIN = val;
//}

void mySPI::Init(void) {
  pinMode(10,OUTPUT);
  pinMode(_SCK, OUTPUT);
  pinMode(_MOSI, OUTPUT);
  pinMode(_CD, OUTPUT);
//  pinMode(_CS_PIN, OUTPUT); 

  /*
    SPR1 SPR0
   	0	0		fclk/4
   	0	1		fclk/16
   	1	0		fclk/64
   	1	1		fclk/128
   */
  SPCR = 0;
  SPCR =  (1<<SPE) | (1<<MSTR) | (0<<SPR1) | (0<<SPR0) | (0<<CPOL) | (0<<CPHA); 
}

unsigned char mySPI::send(unsigned char data)
{
  /* unsigned char x = 100; */
  /* send data */
  SPDR = data;
  /* wait for transmission */
  while (!(SPSR & (1<<SPIF))) 
    ;
   
  /* clear the SPIF flag by reading SPDR */
  return  SPDR;
}


