/*
         programs.h
 
 (c)2014 ARPix / Alexander Röhl

*/

void menu() {
  if (SELECT_STATE) { 
    myDOG.displayClear();
    myDOG.print("Current settings:",0,0); 
    myDOG.print("Baud:",0,1); 
    myDOG.print(CURRENT_BAUD,30,1);
    delay(1);
    myDOG.print(" {  I Set I    I",0,7); 
    SELECT_STATE = 0;
  }
  
  BT_Menu ();
}

void startSerial() {
  if (SELECT_STATE) { 
    myDOG.displayClear();
    myDOG.print("Start reading", 20, 3);
    delay(2000);
    myDOG.displayClear();
    myDOG.print(" ]  I     I     I [ ",0,7); 
    SELECT_STATE = 0;
  }

  if (Serial.available() > 0 && READ_STATE) {
    value = Serial.read();
    
    if (value > 10 && value != 13) {
      txt[i] = (char)value;
      i++;
    }
    
    if (value == 13) {
      myDOG.print(txt, row++);
      Serial.println(txt);
      if (row == 7) {
        row = 0; 
        myDOG.displayClear();
        myDOG.print(" ]  I     I     I [ ",0,7); 
      }
      
      for (int g=0; g < sizeof(txt); g++) txt[g] = 0;
      i = 0;
    }
  }

  BT_Serial();
}


void settings() {
  if (SELECT_STATE) { 
    myDOG.displayClear();
    myDOG.print("Settings",0,0);
    myDOG.print("Baud:",0,1); 
    
    myDOG.print("1200    14400",7*5,1);
    myDOG.print("2400    19200",7*5,2);
    myDOG.print("4800    38400",7*5,3); 
    myDOG.print("7200    57600",7*5,4);
    myDOG.print("9600   115200",7*5,5);
    
    myDOG.print(" ^  I  _  I  `  I [",0,7); 
 
    SELECT_STATE = 0;
  }
  
  // Column 1
  if (UPDOWN_ROW_POS < 1 && UPDOWN_COL_POS == 6) { UPDOWN_ROW_POS = 1; }
  if (UPDOWN_ROW_POS > 5 && UPDOWN_COL_POS == 6) { UPDOWN_COL_POS = 13; UPDOWN_ROW_POS = 1; BAUD_ARRAY_INDEX = 1; }

  // Column 2
  if (UPDOWN_ROW_POS < 1 && UPDOWN_COL_POS == 13) { UPDOWN_COL_POS = 6; UPDOWN_ROW_POS = 5; BAUD_ARRAY_INDEX = 0; }
  if (UPDOWN_ROW_POS > 5 && UPDOWN_COL_POS == 13) { UPDOWN_ROW_POS = 5; }
  
  myDOG.print(">", UPDOWN_COL_POS*5, UPDOWN_ROW_POS);

  
  BT_Settings();
}

/////////////////////////////////////////
// PROGRAM MODE
/////////////////////////////////////////
void mode() {
   switch (PROGRAMM_MODUS) {
     case 0:
        menu();
        break; 
     case 1:
        startSerial();
        break; 
     case 2:
        settings();
        break; 
    }
}
